\documentclass{revtex4}

\usepackage{graphicx}
\usepackage{amssymb,amsmath}
\usepackage{epstopdf}
\usepackage{bm}
\usepackage{dsfont}
\usepackage{color}

\DeclareGraphicsRule{.tif}{png}{.png}{`convert #1 `dirname #1`/`basename #1 .tif`.png}

\newcommand{\abs}[1]{\left|#1\right|}
\newcommand{\trn}[1]{{#1}^{\mathsf{T}}}
\newcommand{\diagOf}[1]{\left\lbrace#1\right\rbrace}

\begin{document}
\title{NeuroCorr}
\maketitle

\section{Data Description}
We have a set of $M$ trials (indexed by $j$) performed on $N$ neurons (indexed by $i$).
Each trial is a set of $N$ trains $\mathcal{T}_{j,i}$ with a
given number of spikes $S_{j,i}$ occurring at times $\tau_{j,i,q}, q\in[1:S_{j,i}]$.
Here, we will assume that the times are integer for a given time scale (millisecond, microsecond, nanosecond...).

\section{Counting interaction function}
\subsection{Description}
An counting interaction function is described by two parameters and acting on any train $\mathcal{T}_z$: a time length $\delta$ and a number
of shifts $k$ ($0\leq k < K$):
$$
	\Phi_{z,k,\delta}(t) = 
	\sum_{u\in\tau_{z}}
	 \mathds{1}_{(t-u)\in\mathbb{I}_k,\mathbb{I}_k=\rbrack k\delta,(k+1)\delta\rbrack}
$$
This expression is the number of points in $\lbrack t-(k+1)\delta,t-k\delta\lbrack$, and all the $\Phi$ functions
are hence left-continuous, constant piecewise functions.
In particular,
$$
	\Phi_{z,k,\delta}(t) = \Phi_{z,0,\delta}(t-k\delta).
$$
so we only need to compute a source function for a given train, and the following functions are computed by just
a shift in the partition.

\subsection{Implementation}
\subsubsection{Description}
We described a CPW function by a list/vector of \textbf{sorted} coordinates $\tau_i,F_i$.
and a '$\mathrm{foot}$' before the first coordinate. If the function has no coordinate, this
is the constant function...with constant value=$\mathrm{foot}$.
In summary, let $F(t)$ be a CPW function with $n_F$  coordinates and a foot value.
\begin{itemize}
	\item if $n_F=0$ then $F(t)\equiv\mathrm{foot}$.
	\item if $n_F>0$ then
	\begin{itemize}
		\item $F(t\leq\tau_0) = \mathrm{foot}$
		\item $F(\tau_{i}<t\leq\tau_{i+1}) = F_i$
		\item $F(t>\tau_{n_F-1})           = F_{n_F-1}$
	\end{itemize}
\end{itemize}

\subsubsection{Algorithm to build the source function}
Mine: Specific List Fusion + duplicate removal.

\subsubsection{Evaluation}

\subsubsection{Sum over sorted times}

\subsubsection{Product construction}

\subsubsection{Integration}


\section{Boxes-wise computation}
\subsection{Using boxes}
A box $B$ is described by a trial index $j$ (with its $N$ corresponding trains, one per neuron),
a starting time $\tau_{s}$, a final time $\tau_{f}$, and a biological behaviour $\beta$.

\subsection{Right-hand column-vectors $\mu_1,\mu_2,\mu_A$}
{\bf For a given $j$}, the matrices $\mu_1$ and $\mu_2$ have $N$ columns and $1+NK$ rows,
the matrix $\mu_A$ got 1 column and $1+NK$ rows.
For each neuron $N_{j,i}$, we make a new column $\mu_{X,_i}$.
We start by collecting the list $\lambda_{j,i}=\lbrace\tau_{j,i}\in\left\rbrack\tau_s,\tau_f\right\rbrack\rbrace$,
which is a (shorter) list of sorted times.
\begin{itemize}
\item
The first line are
$$
	\mu_1(1,i) = \mu_2(1,i) = \#\lbrace\lambda_{j,i}\rbrace, \mu_A(1,1) =1.
$$
\item
The following lines are defined for each neuron $l$, using the $K$ values
$$
	\mu_1(2+(Kl)+k,i) = \sum_{\tau\in\lambda_{j,i}} \Phi_{j,l,k,\delta}(\tau)
$$
$$
	\mu_2(2+(Kl)+k,i) = \sum_{\tau\in\lambda_{j,i}} \left(\Phi_{j,l,k,\delta}(\tau)\right)^2
$$
$$
	\mu_A(2+(Kl)+k,i) = \max_{\tau\in\left\rbrack\tau_s,\tau_f\right\rbrack} \left| \Phi_{j,l,k,\delta}(\tau) \right|
$$
\item During \emph{aggregation}, by kind or by box, we add values or take the maximum value of the target matrix...
\end{itemize}

\subsection{Left-hand Symmetric Matrix ${G}$}
\subsubsection{Definition}
The $\mathcal{G}$ matrix has $1+NK$ lines and columns.
\begin{itemize}
	\item 
		$$ 
		{G}_{1,1} = \tau_f-\tau_s
		$$
	\item for each neuron $i$, then for each index $k$, using $I_{i,k}=1+K\times i + k$,
		\begin{itemize}
		\item compute the side terms
		$$
			{G}_{1,I_{i,k}} = {G}_{I_{i,k},1} = \int_{\tau_s}^{\tau_f} \Phi_{j,i,k}(\tau) \, \mathrm{d}\tau
		$$
		\item for each neuron $l\geq i$, then for each index $m$, compute the core term
		$$
			{G}_{I_{l,m},I_{i,k}} = {G}_{I_{i,k},I_{l,m}}  =
			\int_{\tau_s}^{\tau_f}  \Phi_{j,i,k}(\tau) \Phi_{j,l,m}(\tau) \, \mathrm{d}\tau
		$$
		\end{itemize}
\end{itemize}

\subsubsection{Evaluation}
\begin{itemize}
\item The side terms may be evaluated in parallel from the precomputed functions.

\item The core terms requires the computation of a function product, with is costly
in memory and time. So it is better to evaluate a product, and then 
every box using it perform its own evaluation.
 The parallelism occurs
on the computation of the different products.
\end{itemize}

\section{Finding coefficients}
\subsection{Objective function}
For each columns $\vec{b}$ and $\vec{v}$ of $\mu_1$ and $\mu_2$ respectively, and we search the $p=(1+NK) \times N$ parameters $\vec{a}$ which minimizes
\begin{equation}
	\mathcal{H}\left(\vec{a}\right) = -2\trn{\vec{b}}\vec{a} + \trn{\vec{a}} G \vec{a} +2 \trn{\vec{d}} \abs{\vec{a}}
\end{equation}
with, using $\vec{A}$ as the one column of $\mu_A$, 
\begin{equation}
	\vec{d} = \sqrt{2\gamma \ln p \cdot \vec{v}} + \dfrac{\gamma\ln p}{3} \vec{A}. 
\end{equation}
In the following, $G$ is positive, not necessarily definite.

\subsection{Critical Points}

We want to find the zeros of
\begin{equation}
	\vec{q}\left(\vec{a}\right) = \dfrac{1}{2} \partial_{\vec{a}} \mathcal{H} = G\vec{a} - \vec{b} + \trn{\vec{d}}\vec{\sigma}\left(\vec{a}\right)
\end{equation}
Let us start from a given $\vec{a}$ and find a new value $\tilde{\vec{a}}$.
We write
\begin{equation}
	\forall i, \; d_i \sigma\left(a_i\right) =  b_i  - G_{ii}a_i - \sum_{j\not=i} G_{ij} a_j = D_i - G_{ii}a_i
\end{equation}

\begin{itemize}
	\item If $\sigma\left(a_i\right)=1$, then we should have
		\begin{equation}
			G_{ii} a_i = D_i - d_i
		\end{equation}
		which is compatible only if $D_i>d_i$.
	\item If $\sigma\left(a_i\right)=-1$, then we should have
	\begin{equation}
		G_{ii} a_i = D_i + d_i
	\end{equation}
	which is compatible only if $D_i<-d_i$.
	\item Otherwise, if $\abs{D_i}\leq d_i$, we must have a compatible $a_i=0$.
\end{itemize}

\subsection{Algorithm}
So we estimate the new values by the next compatible values.

\begin{itemize}
	\item We start from ${\vec{a}}^{(n)}$.
	\item We compute
		\begin{equation}
			D_i = b_i - \sum_{j\not=i} G_{ij}a_j^{(n)}
		\end{equation}
	\begin{itemize}
		\item if $D_i>d_i$, 
			\begin{equation}
				a_i^{(n+1)} = \dfrac{D_i-d_i}{G_{ii}} > 0
			\end{equation}
			and we define $\kappa_i^{(n)}=1$.
		\item if $D_i<-d_i$,
			\begin{equation}
				a_i^{(n+1)} = \dfrac{D_i+d_i}{G_{ii}} < 0
			\end{equation}
			and we define $\kappa_i^{(n)}=-1$.
		\item otherwise, if $\abs{D_i}\leq d_i$, 
			\begin{equation}
				a_i^{(n+1)} = 0
			\end{equation}
		and we define $\kappa_i^{(n)}=0$.
	\end{itemize}
\end{itemize}

Let $\bm{\kappa}^{(n)}$ be the diagonal matrix of $\vec{\kappa}^{(n)}$ components,
and let $W$ the diagonal matrix of $1/G_{ii}$.
The corresponding step is
\begin{equation}
	\delta \vec{a}^{(n+1)} = \vec{a}^{(n+1)} - \vec{a}^{(n)} = \abs{\bm{\kappa}^{(n)}} W \left(\vec{b} -  G \vec{a}^{(n)} +  \bm{\kappa}^{(n)} \vec{d} \right)
	+ \left(\abs{\bm{\kappa}^{(n)}} - \bm{I}\right) \vec{a}^{(n)}
%	= 
%	\begin{pmatrix}
%	\frac{\abs{\kappa_1^{(n)}}}{G_{11}} & 0 & \ldots & 0 \\
%	                              & \ddots &    &   \\
%	  &        & \ddots & \\
%	0 & \ldots & 0 & \frac{\abs{\kappa_p^{(n)}}}{G_{pp}}
%	\end{pmatrix}
%	\left( \vec{b} - G \vec{a}^{(n)}+ \vec{d}\otimes\vec{\kappa}^{(n)} \right)
\end{equation}




\end{document}

